NEW: Now suppots JSONPointer Draft 09 and JSONPatch Draft 10 (the latest as of 21/Jan/2012)

[![Build Status](https://secure.travis-ci.org/dharmafly/jsonpatch.js.png)](http://travis-ci.org/dharmafly/jsonpatch.js)

JSONPatch
=========

An implementation of the [JSONPatch][#jsonpatch] (and [JSONPointer][#jsonpointer]) IETF drafts for Node.JS and the Browser (as a plain module or with AMD).

A [Dharmafly][#dharmafly] project written by [Thomas Parslow][#tom] <tom@almostobsolete.net> and released with the kind permission of [NetDev][#netdev].

**For full documentation, see [jsonpatchjs.com][#site]**


Quick Example
-------------

```javascript
    mydoc = {
      "baz": "qux",
      "foo": "bar"
    };
    thepatch = [
      { "op": "replace", "path": "/baz", "value": "boo" }
    ]
    patcheddoc = jsonpatch.apply_patch(mydoc, thepatch);
    // patcheddoc now equals {"baz": "boo", "foo": "bar"}}
```

And that's all you need for basic use, if the patch is invalid or won't apply then you'll get an error thrown. The original doc is NOT mutated so you can use it for other things afterwards. For more see the [docs][#site].

Is it any good?
---------------

Yes, I hope so

Does it work in the browser?
----------------------------

Yes. The tests will run in the browser as well if you want to check. It's been tested in modern browsers and even in IE6!


Does it work with Node.JS?
--------------------------

Yes. Install with:

    npm install jsonpatch

Is it finished?
---------------

Probably, unless the spec changes again :)

Are there tests?
----------------

Yes, there are tests. It also passes JSHint.


Origin of the project
---------------------

[Dharmafly][#dharmafly] is currently working to create a collaboration web app for [NetDev][#netdev] that comprises a [Node.js][#nodejs] RESTful API on the back-end and an HTML5 [Backbone.js][#backbone] application on the front. The JSON Patch library was created as an essential part of the RESTful API, and has been subsequently open sourced for the community with NetDev's permission.

I've fixed/improved stuff
-------------------------

Great! Send me a pull request [through GitHub](http://github.com/dharmafly/jsonpatch.js) or get in touch on Twitter [@almostobsolete][#tom-twitter] or email at tom@almostobsolete.net

[#site]:http://jsonpatchjs.com
[#tom]: http://www.almostobsolete.net
[#tom-twitter]: https://twitter.com/almostobsolete
[#netdev]: http://www.netdev.co.uk
[#dharmafly]: http://dharmafly.com
[#nodejs]: http://nodejs.org
[#backbone]: http://documentcloud.github.com/backbone/
[#jsonpatch]: https://datatracker.ietf.org/doc/draft-ietf-appsawg-json-patch/
[#jsonpointer]: https://datatracker.ietf.org/doc/draft-ietf-appsawg-json-pointer/